VERSION 5.00
Begin VB.Form frmTTF 
   Caption         =   "TTF"
   ClientHeight    =   4380
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6615
   LinkTopic       =   "Form1"
   ScaleHeight     =   4380
   ScaleWidth      =   6615
   StartUpPosition =   3  'Windows Default
   Begin VB.DirListBox Dir1 
      Height          =   990
      Left            =   1440
      TabIndex        =   5
      Top             =   480
      Width           =   2535
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   1440
      TabIndex        =   4
      Top             =   120
      Width           =   2535
   End
   Begin VB.FileListBox File1 
      Height          =   1260
      Left            =   4080
      Pattern         =   "*.ttf"
      TabIndex        =   3
      Top             =   120
      Width           =   2415
   End
   Begin VB.OptionButton optNames 
      Caption         =   "List Names"
      Height          =   195
      Left            =   0
      TabIndex        =   2
      Top             =   600
      Width           =   1455
   End
   Begin VB.OptionButton optTables 
      Caption         =   "List Tables"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   240
      Value           =   -1  'True
      Width           =   1455
   End
   Begin VB.ListBox List1 
      Height          =   2400
      Left            =   120
      TabIndex        =   0
      Top             =   1680
      Width           =   6375
   End
End
Attribute VB_Name = "frmTTF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal s As String, ByVal count As Long) As Long

Dim CurrentOption As Integer


Private Type OffsetTable
    sfntVersion As Long
    numTables As Integer
    searchRange As Integer
    entrySelector As Integer
    rangeShift As Integer
End Type

Private Type TableDirectoryEntry
    tag As String * 4
    checkSum As Long
    offset As Long
    length As Long
End Type

Private Type NamingTable
    FormatSelector As Integer
    NameRecords As Integer
    offsStrings As Integer
End Type

Private Type NameRecord
    PlatformID As Integer
    PlatformSpecific As Integer
    LanguageID As Integer
    NameID As Integer
    StringLength As Integer
    StringOffset As Integer
End Type

Private OT As OffsetTable

Function GetNameForID(ByVal id As Long) As String
    Dim s As String
    Select Case id
        Case 0
            s = "Copyright"
        Case 1
            s = "Font Family"
        Case 2
            s = "Font subfamily"
        Case 3
            s = "Font Identifier"
        Case 4
            s = "Full Font Name"
        Case 5
            s = "Version"
        Case 6
            s = "Postscript name"
        Case 7
            s = "Trademark"
        Case Else
            s = "Unknown"
    End Select

    GetNameForID = s
End Function

Function GetPlatformForID(ByVal id As Long) As String
    Dim s As String
    Select Case id
        Case 0
            s = "Apple Unicode"
        Case 1
            s = "Macintosh"
        Case 2
            s = "ISO"
        Case 3
            s = "Microsoft"
    End Select
    GetPlatformForID = s

End Function

Sub LoadFontInfo(filename As String, List1 As ListBox, mode As Integer)
    Dim fileid As Integer
    Dim TD As TableDirectoryEntry
    Dim NT As NamingTable
    Dim NR As NameRecord
    Dim n As Long
    Dim NTStart As Long     ' Start of naming table
    Dim CurrentLoc As Long  ' Current location in file
    Dim nrnum As Long
    Dim nameinfo As String
    Dim UnicodeName() As Integer
    Dim x As Integer

    List1.Clear
    fileid = FreeFile  ' Get a file ID

    Open filename For Binary Access Read As #fileid
    Get #fileid, , OT ' Retrieve the offset table
    Debug.Print Seek(fileid)
    List1.AddItem "Version " & Hex$(SwapLong(OT.sfntVersion))
    List1.AddItem "Tables " & SwapInteger(OT.numTables)
    
    Select Case mode
        Case 0  ' List all tables
                For n = 1 To SwapInteger(OT.numTables)
                    Get #fileid, , TD
                    List1.AddItem TD.tag
                Next n
        Case 1  ' Name Information
                For n = 1 To SwapInteger(OT.numTables)
                    Get #fileid, , TD
                    If TD.tag = "name" Then
                        ' Seek to the specified location in the file
                        NTStart = SwapLong(TD.offset) + 1
                        Seek #fileid%, NTStart
                        Get #fileid%, , NT
                        List1.AddItem "NumRecords " & SwapInteger(NT.NameRecords)
                        For nrnum& = 1 To SwapInteger(NT.NameRecords)
                            Get #fileid, , NR
                            List1.AddItem "NameRecord # " & nrnum&
                            List1.AddItem "  Platform ID: " & GetPlatformForID(SwapInteger(NR.PlatformID))
                            List1.AddItem "  NameID: " & GetNameForID(SwapInteger(NR.NameID))
                            Select Case SwapInteger(NR.PlatformID)
                                Case 1
                                    ' Mark the current location in the file
                                    CurrentLoc = Seek(fileid)
                                    ' Calculate the length of the string
                                    nameinfo = String$(SwapInteger(NR.StringLength), 0)
                                    ' Calculate the location of the string
                                    Get #fileid, NTStart + SwapInteger(NT.offsStrings) + SwapInteger(NR.StringOffset), nameinfo
                                    List1.AddItem "  " & nameinfo
                                    ' Restore the previous location
                                    Seek #fileid, CurrentLoc
                                Case 3
                                    ' Mark the current location in the file
                                    CurrentLoc = Seek(fileid)
                                    ' Calculate the length of the string
                                    ReDim UnicodeName((SwapInteger(NR.StringLength) / 2) - 1) ' Upper bound is # chars - 1
                                    ' Calculate the location of the string
                                    nameinfo = ""
                                    Get #fileid, NTStart + SwapInteger(NT.offsStrings) + SwapInteger(NR.StringOffset), UnicodeName
                                    For x = 0 To UBound(UnicodeName)
                                        nameinfo = nameinfo & Chr$(SwapInteger(UnicodeName(x)))
                                    Next x
                                    List1.AddItem "  " & nameinfo
                                    ' Restore the previous location
                                    Seek #fileid, CurrentLoc
                                Case Else
                                    List1.AddItem "  - This program only diplays Macintosh and Microsoft strings"
                            End Select
                        Next nrnum

                        Exit For
                    End If
                Next n
    End Select


    Close #fileid

End Sub

'
' Note that we swap the low order bytes in a long so that
' we don't have to worry about overflow problems
'
Function SwapInteger(ByVal i As Long) As Long
    SwapInteger = ((i \ &H100) And &HFF) Or ((i And &HFF) * &H100)
End Function

'
' Swap a long value from Motorola to Intel format or vice versa
'
Function SwapLong(ByVal l As Long) As Long
    Dim addbit As Integer
    Dim newlow As Long, newhigh As Long

    newlow = l \ &H10000
    newlow = SwapInteger(newlow And &HFFFF&)

    newhigh = SwapInteger(l And &HFFFF&)
    If newhigh And &H8000& Then
        ' This would overflow
        newhigh = newhigh And &H7FFF
        addbit = True
    End If
    newhigh = (newhigh * &H10000) Or newlow
    If addbit Then newhigh = newhigh Or &H80000000
    SwapLong = newhigh

End Function


Private Sub Dir1_Change()
    File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()
    Dir1.Path = Drive1.Drive
End Sub

Private Sub File1_Click()
    LoadFontInfo File1.Path & "\" & File1.filename, List1, CurrentOption
End Sub

Private Sub Form_Load()
    Dim charcount As Integer
    Dim s As String
    s = String$(256, 0)
    charcount = GetWindowsDirectory(s, 255)
    s = Left(s, charcount) & "\fonts"
    Dir1.Path = s
    File1.ListIndex = 0
End Sub

Private Sub optNames_Click()
    CurrentOption = 1
    File1_Click
End Sub

Private Sub optTables_Click()
    CurrentOption = 0
    File1_Click
End Sub
