VERSION 5.00
Begin VB.Form prinfo 
   Caption         =   "Printer Info Viewer"
   ClientHeight    =   5010
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5010
   ScaleWidth      =   7365
   Begin VB.CommandButton cmdRect 
      Caption         =   "Rect"
      Height          =   435
      Left            =   120
      TabIndex        =   3
      Top             =   4440
      Width           =   915
   End
   Begin VB.ListBox lstInfo 
      BackColor       =   &H00C0C0C0&
      Height          =   3570
      Left            =   120
      TabIndex        =   2
      Top             =   540
      Width           =   7095
   End
   Begin VB.ComboBox cmbPrinters 
      Height          =   300
      ItemData        =   "prinfo.frx":0000
      Left            =   1800
      List            =   "prinfo.frx":0002
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   120
      Width           =   3315
   End
   Begin VB.Label Label1 
      Caption         =   "Select Printers:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1635
   End
End
Attribute VB_Name = "prinfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Copyright  1996-2004, by Desaware Inc. All Rights Reserved


'   Loads the edit box with information about the DC
'
Private Sub LoadInfo(usehDC As Long)
    Dim a As String
    Dim r As Long
    Dim x As Integer

    lstInfo.Clear
    r = GetDeviceCaps(usehDC, TECHNOLOGY)
    If r And DT_RASPRINTER Then
        lstInfo.AddItem "Raster Printer"
    Else
        lstInfo.AddItem "Non-raster technology"
    End If
    lstInfo.AddItem "Driver version:" & Hex$(GetDeviceCaps(usehDC, DRIVERVERSION))
    lstInfo.AddItem "X,Y Dimensions in mm:" & Str$(GetDeviceCaps(usehDC, HORZSIZE)) & "," & Str$(GetDeviceCaps(usehDC, VERTSIZE))
    lstInfo.AddItem "X,Y Dimensions in pixels:" & Str$(GetDeviceCaps(usehDC, HORZRES)) & "," & Str$(GetDeviceCaps(usehDC, VERTRES))
    lstInfo.AddItem "X,Y Pixels/Logical Inch:" & Str$(GetDeviceCaps(usehDC, LOGPIXELSX)) & "," & Str$(GetDeviceCaps(usehDC, LOGPIXELSY))
    lstInfo.AddItem "Physical Height/Width" & Str$(GetDeviceCaps(usehDC, PHYSICALWIDTH)) & "," & Str$(GetDeviceCaps(usehDC, PHYSICALHEIGHT))
    lstInfo.AddItem "Physical X/Y Margin" & Str$(GetDeviceCaps(usehDC, PHYSICALOFFSETX)) & "," & Str$(GetDeviceCaps(usehDC, PHYSICALOFFSETY))
    
    lstInfo.AddItem "Bits/Pixel:" & Str$(GetDeviceCaps(usehDC, BITSPIXEL))
    lstInfo.AddItem "Color Planes:" & Str$(GetDeviceCaps(usehDC, PLANES))
    lstInfo.AddItem "Color Table Entries:" & Str$(GetDeviceCaps(usehDC, NUMCOLORS))
    lstInfo.AddItem "Aspect X,Y,XY:" & Str$(GetDeviceCaps(usehDC, ASPECTX)) & "," & Str$(GetDeviceCaps(usehDC, ASPECTY)) & "," & Str$(GetDeviceCaps(usehDC, ASPECTXY))
    lstInfo.AddItem "Device Fonts: " & Str$(GetDeviceCaps(usehDC, NUMFONTS))
    r = GetDeviceCaps(usehDC, RASTERCAPS)
    lstInfo.AddItem "Device capabilities:"
    If r And RC_BANDING Then lstInfo.AddItem " Banding"
    If r And RC_BIGFONT Then lstInfo.AddItem " Fonts >64K"
    If r And RC_BITBLT Then lstInfo.AddItem " BitBlt"
    If r And RC_BITMAP64 Then lstInfo.AddItem " Bitmaps >64k"
    If r And RC_DI_BITMAP Then lstInfo.AddItem " Device Independent Bitmaps"
    If r And RC_DIBTODEV Then lstInfo.AddItem " DIB to device"
    If r And RC_FLOODFILL Then lstInfo.AddItem " Flood fill"
    If r And RC_SCALING Then lstInfo.AddItem " Scaling"
    If r And RC_STRETCHBLT Then lstInfo.AddItem " StretchBlt"
    If r And RC_STRETCHDIB Then lstInfo.AddItem " StretchDIB"
    For x = 1 To lstInfo.ListCount
        a = a & lstInfo.List(x) & vbCrLf
    Next x
    Clipboard.SetText a
End Sub

Private Sub cmbPrinters_Click()
    Set Printer = Printers(cmbPrinters.ListIndex)
    LoadInfo Printer.hDC
End Sub

' Draws a rectangle that bounds the printed area of the page
Private Sub cmdRect_Click()
    Dim x As Long, y As Long
    Printer.ScaleMode = vbPixels
    Printer.Line (0, 0)-(GetDeviceCaps(Printer.hDC, HORZRES) - 1, GetDeviceCaps(Printer.hDC, VERTRES) - 1), , B
    Printer.EndDoc
End Sub

Private Sub Form_Load()
    Dim x As Integer
    Dim currentprinter As Integer
    For x = 0 To Printers.Count - 1
        cmbPrinters.AddItem Printers(x).DeviceName
        If Printers(x).DeviceName = Printer.DeviceName Then currentprinter = x
    Next x
    cmbPrinters.ListIndex = currentprinter
End Sub

